;-------------------------------------------------------------------------------
; Ct Helper   gui
;
;   Copyright (C) 2008, 2009 Alesc
;   This program is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License.
;-------------------------------------------------------------------------------

;-------------------------------------------------------------------------------
; options gui
;-------------------------------------------------------------------------------
CreateOptionsGUI()
{
    global
    local selectedFile, selectedPath

    ; create and show options gui
    Gui, %options_GUIhandle%:Add, GroupBox, x6 y4 w390 h130 , PSPad settings
    Gui, %options_GUIhandle%:Add, Text, x36 y24 w120 h20 , Hots hotkey
    Gui, %options_GUIhandle%:Add, Hotkey, x186 y24 w120 h20 +Left vpsp_action_key_gui, 
    Gui, %options_GUIhandle%:Add, Picture, x156 y24 w20 h20 vhotsHotkeyPic, .\resources\%hotsHotkeyPicflag%
    psp_action_key_gui_TT := "Hots hotkey calls jscript function in pspad."

    Gui, %options_GUIhandle%:Add, GroupBox, x6 y144 w390 h110 , Program settings
    Gui, %options_GUIhandle%:Add, Text, x16 y194 w120 h20 , Source path:
    Gui, %options_GUIhandle%:Add, Edit, x146 y194 w210 h20 vsrc_path_gui,
    srcPathGui_TT := "Root path to all sources."
    Gui, %options_GUIhandle%:Add, Picture, x116 y194 w20 h20 vsrcPathPic, .\resources\%srcPathPicflag%
    Gui, %options_GUIhandle%:Add, Button, x356 y194 w20 h20 gBrowseSrcPath, ...

    Gui, %options_GUIhandle%:Add, Button, x126 y344 w100 h30 gOptionsSave, Save
    Gui, %options_GUIhandle%:Add, Button, x246 y344 w100 h30 gOptionsCancel, Cancel
    Gui, %options_GUIhandle%:Add, Button, x366 y344 w100 h30 gOptionsHelp, Help
    Gui, %options_GUIhandle%:Show, x238 y115 h379 w479, Ct Helper options
    OnMessage(0x200, "WM_MOUSEMOVE")

    ; read saved options
    IniRead, PSP_ACTION_KEY, %iniCt%, PSPad settings, hots hotkey

    IniRead, SRC_PATH, %iniCt%, Program settings, Source path

    ; update gui with saved options
    GuiControl, %options_GUIhandle%:, psp_action_key_gui, %PSP_ACTION_KEY%
    GuiControl, %options_GUIhandle%:, src_path_gui, %SRC_PATH%

    Gui_CheckOptions()
}

OptionsSave:
    Gui, %options_GUIhandle%:Submit, NoHide

    if Gui_CheckOptions() = HOT_ERR
        return

    if CheckOptions() = HOT_ERR
        return

    IniWrite, %PSP_ACTION_KEY%, %iniCt%, PSPad settings, hots hotkey
    IniWrite, %SRC_PATH%, %iniCt%, Program settings, Source path

    Gui, %options_GUIhandle%:Destroy
return

Gui_CheckOptions()
{
    global
    local tmpHotshotkey
    local tmpSrcPath
    local retval := HOT_OK

    tmpHotshotkey := PSP_ACTION_KEY
    tmpSrcPath := SRC_PATH

    GuiControlGet, psp_action_key_gui, %options_GUIhandle%:
    GuiControlGet, src_path_gui, %options_GUIhandle%:

    PSP_ACTION_KEY := psp_action_key_gui
    SRC_PATH := src_path_gui

    if CheckOptions() = HOT_ERR
    {
        ; restore globals
        PSP_ACTION_KEY := tmpHotshotkey
        SRC_PATH := tmpSrcPath
        retval := HOT_ERR
    }

    GuiControl, %options_GUIhandle%:, hotsHotkeyPic, .\resources\%hotsHotkeyPicflag%
    GuiControl, %options_GUIhandle%:, srcPathPic, .\resources\%srcPathPicflag%

    return %retval%
}

OptionsCancel:
    Gui, %options_GUIhandle%:Destroy
return

OptionsHelp:
    HelpStart()
return

BrowseSrcPath:
    Gui, %options_GUIhandle%:+OwnDialogs
    FileSelectFolder, selectedPath,, 3
    if selectedPath <>
        GuiControl, %options_GUIhandle%:, src_path_gui, %selectedPath%
return

WM_MOUSEMOVE()
{
    ; _TT is kept blank for use by the ToolTip command below.
    static CurrControl, PrevControl, _TT
    CurrControl := A_GuiControl
    If (CurrControl <> PrevControl and not InStr(CurrControl, " "))
    {
        ; Turn off any previous tooltip.
        ToolTip
        SetTimer, DisplayToolTip, 1000
        PrevControl := CurrControl
    }
    return

    DisplayToolTip:
    SetTimer, DisplayToolTip, Off
    IfInString, CurrControl, ...
        return
    ; The leading percent sign tell it to use an expression.
    ToolTip % %CurrControl%_TT
    SetTimer, RemoveToolTip, 3000
    return

    RemoveToolTip:
    SetTimer, RemoveToolTip, Off
    ToolTip
    return
}
;-------------------------------------------------------------------------------
; about gui
;-------------------------------------------------------------------------------
AboutCtHelper()
{
    global

    Gui, %about_GUIhandle%:Color, Blue
    Gui, %about_GUIhandle%:Add, Picture, x6 y4 w200 h170 , .\resources\helper_about.jpg
    Gui, %about_GUIhandle%:Add, Button, x256 y294 w100 h30 gAboutOk, OK
    Gui, %about_GUIhandle%:Font, s20
    Gui, %about_GUIhandle%:Add, Text, x206 y4 w150 h50 cWhite +Center, %title%
    Gui, %about_GUIhandle%:Font, s10
    Gui, %about_GUIhandle%:Add, Text, x210 y90 w180 h20 cWhite +Left, Program version: 
    Gui, %about_GUIhandle%:Font, Bold
    Gui, %about_GUIhandle%:Add, Text, x316 y90 w30 h20 cWhite +Center, %version%
    Gui, %about_GUIhandle%:Font, s10 Norm
    Gui, %about_GUIhandle%:Add, Text, x210 y110 w150 h80 cWhite +Left, Author: 
    Gui, %about_GUIhandle%:Font, Bold
    Gui, %about_GUIhandle%:Add, Text, x315 y110 w50 h80 cWhite +Center, Alesc
    Gui, %about_GUIhandle%:Show, Center h343 w369, About CtHelper
    return
}

AboutOk:
    Gui, %about_GUIhandle%:Destroy
return
