;-------------------------------------------------------------------------------
; Debuging lib functions
;
;   Copyright (C) 2008, 2009 Alesc
;   This program is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License.
;-------------------------------------------------------------------------------

WriteDebugEnv(prog, value)
{
    variable = %prog%_DEBUG
    EnvSet, %variable%, %value%
}
ReadDebugEnv(prog)
{
    global DEBUG

    variable = %prog%_DEBUG
    EnvGet, DEBUG, %variable%
    if DEBUG <> 1
        DEBUG = 0
}
DebugInit(dbg_path, dbg_filename)
{
    global DEBUG_FILE, DEBUG

    if DEBUG <> 1
        return

    FormatTime, debug_time

    dbg_hdr_top = --------------------------------------------------------------
    dbg_hdr_middle = Debug log system
    dbg_hdr_middle2 := "`tCreated by: " . A_ScriptName . "`r`n`tCreation time: " . debug_time
    dbg_hdr_bottom = ---------------------------------------------------------------

    debug_hdr := dbg_hdr_top . "`r`n" . dbg_hdr_middle . "`r`n" . dbg_hdr_middle2 . "`r`n" . dbg_hdr_bottom . "`r`n"
    DEBUG_FILE = %dbg_path%\%dbg_filename%
    FileDelete, %DEBUG_FILE%
    FileAppend, %debug_hdr%, %DEBUG_FILE%
}
DebugExit()
{
    global DEBUG_FILE, DEBUG

    if DEBUG <> 1
        return

    dbg_foot = --------------------------------------------------------------
    dbg_foot := "`r`n" . End debug log system . "`r`n"
    dbg_foot := dbg_foot . "--------------------------------------------------------------"
    FileAppend, %dbg_foot%, %DEBUG_FILE%
}
DbgPrint(dbg_line)
{
    global DEBUG, DEBUG_FILE

    if DEBUG
        FileAppend, %dbg_line%`r`n, %DEBUG_FILE%
    return
}
DbgIn(func_name)
{
    global DEBUG

    if DEBUG
        DbgPrint("[" . func_name . ">")
    return
}
DbgOut(func_name)
{
    global DEBUG

    if DEBUG
        DbgPrint("<" . func_name . "]")
    return
}
