;-------------------------------------------------------------------------------
; setup   gui
;
;   Copyright (C) 2008, 2009 Alesc
;   This program is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License.
;-------------------------------------------------------------------------------
CreateSetupGUI()
{
    global
    local defaultPath

    SETUP_STATE = 1
    SETUP_ERROR_STATE = 5
    HEADER_TXT_STATE1 = Welcome to install wizard for %PROGRAM_INSTALL_NAME%.
    MAIN_TXT_STATE1 = This wizard will install %PROGRAM_INSTALL_NAME% on your computer. To continue, click Next.
    HEADER_TXT_STATE2 = Setup will install %PROGRAM_INSTALL_NAME% in the following folder.
    MAIN_TXT_STATE2 = To install to this folder, click Next. To install to a different folder, click Browse and select another folder.
    HEADER_TXT_STATE3 = Installing
    MAIN_TXT_STATE3 = Please wait while %PROGRAM_INSTALL_NAME% is beeing installed.
    HEADER_TXT_STATE4 = %PROGRAM_INSTALL_NAME% has been installed on your computer.
    MAIN_TXT_STATE4 = Click End to close this wizard.
    HEADER_TXT_STATE5 = Some error happened during install. %PROGRAM_INSTALL_NAME% has not been installed on your computer.
    MAIN_TXT_STATE5 = Click End to close this wizard.

    defaultPath = %A_ProgramFiles%\%PROGRAM_INSTALL_NAME%

    ; first page
    Gui, %setup_GUIhandle%:font, Bold
    Gui, %setup_GUIhandle%:Add, Text, x76 y74 w330 h50 vHeaderTxt Bold, %HEADER_TXT_STATE1%
    Gui, %setup_GUIhandle%:font, Norm
    Gui, %setup_GUIhandle%:Add, Text, x76 y174 w330 h50 vMainTxt, %MAIN_TXT_STATE1%

    ; second page
    Gui, %setup_GUIhandle%:Add, GroupBox, x70 y244 w380 h60 vSetupBox Hidden, Destination folder
    Gui, %setup_GUIhandle%:Add, Edit, x76 y274 w310 h20 vSetupPath Hidden,
    Gui, %setup_GUIhandle%:Add, Button, x386 y274 w30 h20 gBrowseSetupPath vBrowseButton Hidden, ...
    GuiControl, %setup_GUIhandle%:, SetupPath, %defaultPath%

    ; third page
    Gui, %setup_GUIhandle%:Add, Text, x76 y234 w310 h40 vProgressTxt Hidden
    Gui, %setup_GUIhandle%:Add, Progress, x76 y274 w310 h20 vSetupProgress Hidden

    ; fourth page
    Gui, Add, Checkbox, x76 y234 vRunProgram Checked Hidden, Run %PROGRAM_INSTALL_NAME% %VERSION% on exit
    Gui, Add, Checkbox, x76 y254 vCreateDeskLink Hidden, Create desktop shortcut
    Gui, Add, Checkbox, x76 y274 vCreateProgramGroup Hidden, Create %PROGRAM_INSTALL_NAME% program group

    ; common code
    Gui, %setup_GUIhandle%:Add, Picture, x10 y2 w50 h-1, %SETUP_TMP_PATH%\resources\setup_stamp.gif
    Gui, %setup_GUIhandle%:Add, Picture, x80 y10 w300 h-1 AltSubmit, %SETUP_TMP_PATH%\resources\setup_title.gif
    Gui, %setup_GUIhandle%:Add, GroupBox, x10 y50 w460 h15,
    Gui, %setup_GUIhandle%:Add, GroupBox, x10 y305 w460 h15,
    Gui, %setup_GUIhandle%:Add, Button, x76 y324 w100 h30 -Wrap gSetupBack +Disabled vBack, < &Back
    Gui, %setup_GUIhandle%:Add, Button, x196 y324 w100 h30 -Wrap gSetupNext vNext, &Next >
    Gui, %setup_GUIhandle%:Add, Button, x366 y324 w100 h30 -Wrap gSetupCancel vCancel, Cancel

    OnMessage(0x200, "WM_MOUSEMOVE")
    ; show gui
    Gui, Show, x157 y84 w477 h377, Installing %PROGRAM_INSTALL_NAME% %VERSION%
}

SetupCancel:
    Gui, %setup_GUIhandle%:Destroy
    DeinitCORElib(TITLE)
    ExitApp
return

SetupNext:
    SETUP_STATE := SETUP_STATE + 1
    UpdateGUIbyState()
return

SetupBack:
    SETUP_STATE := SETUP_STATE - 1
    UpdateGUIbyState()
return

UpdateGUIbyState()
{
    global
    local instSuccess

    ; end was clicked...exit
    if SETUP_STATE = 5
    {
        GuiControlGet, RunProgram, %setup_GUIhandle%:
        GuiControlGet, CreateDeskLink, %setup_GUIhandle%:
        GuiControlGet, CreateProgramGroup, %setup_GUIhandle%:
        if CreateProgramGroup = 1
        {
            FileCreateDirEx(A_Programs . "\" . PROGRAM_INSTALL_NAME)
            FileCreateShortcut, %SetupPath%\%PROGRAM_INSTALL_NAME%.exe, %A_Programs%\%PROGRAM_INSTALL_NAME%\%PROGRAM_INSTALL_NAME%.lnk, %SetupPath%,, %PROGRAM_INSTALL_NAME% %version%, %SetupPath%\resources\%PROGRAM_INSTALL_NAME%_icon.ico,,,
            FileCreateShortcut, %SetupPath%\uninstall.exe, %A_Programs%\%PROGRAM_INSTALL_NAME%\Uninstall.lnk, %SetupPath%,, Location: %SetupPath%, %SetupPath%\resources\%PROGRAM_INSTALL_NAME%_uninstall_icon.ico,,,
            FileCreateShortcut, %SetupPath%\%PROGRAM_INSTALL_NAME%_help.html, %A_Programs%\%PROGRAM_INSTALL_NAME%\%PROGRAM_INSTALL_NAME%_help.lnk, %SetupPath%,, Location: %SetupPath%,,,,
        }
        if CreateDeskLink = 1
            FileCreateShortcut, %SetupPath%\%PROGRAM_INSTALL_NAME%.exe, %A_Desktop%\%PROGRAM_INSTALL_NAME%.lnk, %SetupPath%,, %PROGRAM_INSTALL_NAME% %version%, %SetupPath%\resources\%PROGRAM_INSTALL_NAME%_icon.ico,,,

        RegWriteEx("REG_DWORD", "HKEY_CURRENT_USER", PROG_REG_KEY, "ProgramGroup", CreateProgramGroup)
        RegWriteEx("REG_DWORD", "HKEY_CURRENT_USER", PROG_REG_KEY, "DesktopLink", CreateDeskLink)
        ; recompile scripts
        SendToPSP("!T", 1, 0)
        SendToPSP("{Right}", 1, 0)
        SendToPSP("{Enter}", 1, 0)

        if RunProgram = 1
            Run, %SetupPath%\%PROGRAM_INSTALL_NAME%.exe
        Gui, %setup_GUIhandle%:Destroy
        DeinitCORElib(TITLE)
        ExitApp
    }

    GuiControl, %setup_GUIhandle%:, HeaderTxt, % HEADER_TXT_STATE%SETUP_STATE%
    GuiControl, %setup_GUIhandle%:, MainTxt, % MAIN_TXT_STATE%SETUP_STATE%

    GuiControl, %setup_GUIhandle%:Enable, Back
    ; first page
    if SETUP_STATE = 1
        GuiControl, %setup_GUIhandle%:Disabled, Back

    GuiControl, %setup_GUIhandle%:Hide, SetupPath
    GuiControl, %setup_GUIhandle%:Hide, BrowseButton
    GuiControl, %setup_GUIhandle%:Hide, SetupBox
    ; installation folder choose
    if SETUP_STATE = 2
    {
        GuiControl, %setup_GUIhandle%:Show, SetupPath
        GuiControl, %setup_GUIhandle%:Show, BrowseButton
        GuiControl, %setup_GUIhandle%:Show, SetupBox
    }

    GuiControl, %setup_GUIhandle%:Hide, ProgressTxt
    GuiControl, %setup_GUIhandle%:Hide, SetupProgress
    ; go install
    if SETUP_STATE = 3
    {
        GuiControlGet, SetupPath, %setup_GUIhandle%:
        GuiControl, %setup_GUIhandle%:Disabled, Back
        GuiControl, %setup_GUIhandle%:Disabled, Next
        GuiControl, %setup_GUIhandle%:Show, ProgressTxt
        GuiControl, %setup_GUIhandle%:Show, SetupProgress
        instSuccess := Install()
        SETUP_STATE := SETUP_STATE + 1
    }

    ; installaion finised page
    if SETUP_STATE = 4
    {
        GuiControl, %setup_GUIhandle%:Hide, ProgressTxt
        GuiControl, %setup_GUIhandle%:Hide, SetupProgress

        GuiControl, %setup_GUIhandle%:Show, RunProgram
        GuiControl, %setup_GUIhandle%:Show, CreateDeskLink
        GuiControl, %setup_GUIhandle%:Show, CreateProgramGroup
        if instSuccess = %HOT_ERR%
        {
            GuiControl, %setup_GUIhandle%:, HeaderTxt, % HEADER_TXT_STATE%SETUP_ERROR_STATE%
            GuiControl, %setup_GUIhandle%:, MainTxt, % MAIN_TXT_STATE%SETUP_ERROR_STATE%
        }
        else
        {
            GuiControl, %setup_GUIhandle%:, HeaderTxt, % HEADER_TXT_STATE%SETUP_STATE%
            GuiControl, %setup_GUIhandle%:, MainTxt, % MAIN_TXT_STATE%SETUP_STATE%
        }

        GuiControl, %setup_GUIhandle%:Disabled, Back
        GuiControl, %setup_GUIhandle%:Disabled, Cancel
        GuiControl, %setup_GUIhandle%:Enable, Next
        GuiControl, %setup_GUIhandle%:, Next, &End
    }

    return
}

BrowseSetupPath:
    Gui, %setup_GUIhandle%:+OwnDialogs
    FileSelectFolder, selectedPath, %A_ProgramFiles%,
    if selectedPath <>
        GuiControl, %setup_GUIhandle%:, SetupPath, %selectedPath%
return

UpdateProgressText(action)
{
    global
    GuiControl,, ProgressTxt, %action%
}

UpdateProgressBar()
{
    global
    local InstallIndex

    CURRENT_ACTION := CURRENT_ACTION + 1
    InstallIndex := Ceil((100 * CURRENT_ACTION) / SETUP_ACTIONS)
    GuiControl,, SetupProgress, %InstallIndex%
    GuiControl,, ProgressTxt,
}

WM_MOUSEMOVE()
{
    ; _TT is kept blank for use by the ToolTip command below.
    static CurrControl, PrevControl, _TT
    CurrControl := A_GuiControl

    If (CurrControl <> PrevControl and not InStr(CurrControl, " "))
    {
        ; Turn off any previous tooltip.
        ToolTip
        SetTimer, DisplayToolTip, 1000
        PrevControl := CurrControl
    }
    return

    DisplayToolTip:
    SetTimer, DisplayToolTip, Off
    IfInString, CurrControl, ...
        return
    ; The leading percent sign tell it to use an expression.
    ToolTip % %CurrControl%_TT
    SetTimer, RemoveToolTip, 3000
    return

    RemoveToolTip:
    SetTimer, RemoveToolTip, Off
    ToolTip
    return
}

;-------------------------------------------------------------------------------
; about gui
;-------------------------------------------------------------------------------
AboutSetup()
{
    global

    Gui, %about_GUIhandle%:Color, Green
    Gui, %about_GUIhandle%:Add, Picture, x6 y4 w200 h170 , %SETUP_TMP_PATH%\resources\hots_about.jpg
    Gui, %about_GUIhandle%:Add, Button, x256 y294 w100 h30 gAboutOk, OK
    Gui, %about_GUIhandle%:Font, s20
    Gui, %about_GUIhandle%:Add, Text, x206 y4 w150 h50 cWhite +Center, %TITLE%
    Gui, %about_GUIhandle%:Font, s10
    Gui, %about_GUIhandle%:Add, Text, x210 y90 w180 h20 cWhite +Left, Program version: 
    Gui, %about_GUIhandle%:Font, Bold
    Gui, %about_GUIhandle%:Add, Text, x316 y90 w30 h20 cWhite +Center, %VERSION%
    Gui, %about_GUIhandle%:Font, s10 Norm
    Gui, %about_GUIhandle%:Add, Text, x210 y110 w150 h80 cWhite +Left, Author: 
    Gui, %about_GUIhandle%:Font, Bold
    Gui, %about_GUIhandle%:Add, Text, x315 y110 w50 h80 cWhite +Center, Alesc
    Gui, %about_GUIhandle%:Font, s10 Norm
    Gui, %about_GUIhandle%:Add, Text, x6 y194 cWhite, Home web page:
    Gui, %about_GUIhandle%:Font, s10 Norm underline
    ProjWWW = %PROGRAM_INSTALL_NAME%
    Gui, %about_GUIhandle%:Add, Text, x120 y194 cWhite gLaunchProjWWW vWWW, http://%ProjWWW%.sourceforge.net/
    WWW_TT := "Click"
    Gui, %about_GUIhandle%:Show, Center h343 w369, About Setup
    return
}

AboutOk:
    Gui, %about_GUIhandle%:Destroy
return
